# Generated by Django 4.1.7 on 2023-06-20 12:51

from django.db import migrations

import pgtrigger.compiler
import pgtrigger.migrations


class Migration(migrations.Migration):

    dependencies = [
        ("documents", "0004_initial"),
    ]

    operations = [
        pgtrigger.migrations.AddTrigger(
            model_name="elementpath",
            trigger=pgtrigger.compiler.Trigger(name="unique_element_orderings", sql=pgtrigger.compiler.UpsertTriggerSql(constraint="CONSTRAINT", func="\n                IF EXISTS (\n                    SELECT 1\n                    FROM documents_elementpath p\n                    WHERE\n                        p.path && NEW.path\n                        AND p.path[array_length(p.path, 1)] = NEW.path[array_length(NEW.path, 1)]\n                        AND p.element_id = NEW.element_id\n                        AND p.ordering <> NEW.ordering\n                ) THEN\n                    RAISE EXCEPTION 'Each element may only have one ordering within the same parent';\n                END IF;\n                RETURN NULL;\n                ", hash="ede7bc92910da8dae8ea06625d9d3b08f216831c", operation="INSERT OR UPDATE", pgid="pgtrigger_unique_element_orderings_340d8", table="documents_elementpath", timing="DEFERRABLE INITIALLY DEFERRED", when="AFTER")),
        ),
        pgtrigger.migrations.AddTrigger(
            model_name="elementpath",
            trigger=pgtrigger.compiler.Trigger(name="unique_parent_orderings", sql=pgtrigger.compiler.UpsertTriggerSql(constraint="CONSTRAINT", func="\n                IF EXISTS (\n                    SELECT 1\n                    FROM documents_elementpath p\n                    WHERE\n                        p.path && NEW.path\n                        AND p.path[array_length(p.path, 1)] = NEW.path[array_length(NEW.path, 1)]\n                        AND p.ordering = NEW.ordering\n                        AND p.element_id <> NEW.element_id\n                ) THEN\n                    RAISE EXCEPTION 'Each element within a parent must have a distinct ordering';\n                END IF;\n                RETURN NULL;\n                ", hash="45b3745ab2856a2e48ff3e4fc8430b1abda961e5", operation="INSERT OR UPDATE", pgid="pgtrigger_unique_parent_orderings_bbcd7", table="documents_elementpath", timing="DEFERRABLE INITIALLY DEFERRED", when="AFTER")),
        ),
        migrations.RemoveConstraint(
            model_name="elementpath",
            name="unique_element_orderings",
        ),
        migrations.RemoveConstraint(
            model_name="elementpath",
            name="unique_parent_orderings",
        ),
    ]
